%define lib_major 0
%define release %mkrel 1

# optional compile flags
%define enable_python 1
%{?_without_python: %define enable_python 0}

%define enable_mmx 0
%{?_with_mmx: %define enable_mmx 1}

%define enable_sse 0
%{?_with_sse: %define enable_sse 1}

%define enable_lzw 0
%{?_with_lzw: %define enable_lzw 1}

%if %enable_sse
%define enable_mmx 1
%endif

%define version 2.2.17
%define req_gtk_version 2.8.0

%define api_version 2.0
%define abi_version 2.2
%define libname	%mklibname gimp %{api_version} %{lib_major}
%define devlibname	%mklibname gimp %{api_version}

Summary:	The GNU Image Manipulation Program
Name:		gimp
Epoch:		1
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Graphics
URL:		http://www.gimp.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Source0:	ftp://ftp.gimp.org/pub/gimp/v%{abi_version}/gimp-%version.tar.bz2
Source13:	gimp-scripting-sample.pl
Patch4:		gimp-2.3.10-www.patch
Patch6:         gimp-2.3.10-fixname.patch
Patch7:         gimp-2.3.18-fix-mimetypes.patch
# (Abel) Make sure no gimp library is present, otherwise new package
# will link with old library. Damn libtool. Brain-damaged.
BuildConflicts:	libgimp1.3 libgimp1.3-devel
BuildRequires:	ImageMagick
BuildRequires:	aalib-devel
BuildRequires:	gtk-doc >= 1.0
BuildRequires:  libexif-devel
BuildRequires:	libart_lgpl-devel
BuildRequires:	libgtk+2.0-devel >= %{req_gtk_version}
BuildRequires:	libgnomeui2-devel
BuildRequires:	libalsa-devel
BuildRequires:	libpoppler-devel
BuildRequires:	libmng-devel
BuildRequires: 	libpng-devel
BuildRequires:	libtiff-devel
BuildRequires:	perl
BuildRequires:	xpm-devel
BuildRequires:  librsvg-devel
BuildRequires:	libxmu-devel
BuildRequires:	intltool 
# mail plugin
BuildRequires:	sendmail-command
# help browser
BuildRequires:	gtkhtml2-devel >= 1.99.5
# print plugin
#BuildRequires:	libgimpprint-devel >= 4.2.0
# python plugin
%if %enable_python
BuildRequires:	pygtk2.0-devel >= 1.99.12
BuildRequires:	python-devel
%endif
#patch
BuildRequires:  automake1.9
BuildRequires:  lcms-devel libwmf-devel
BuildRequires:  libhal-devel
BuildRequires:  libxext-devel
BuildRequires:  desktop-file-utils
Provides: gimp1_3 gimp2_0 gimp2_2
Obsoletes: gimp1_3 gimp2_0 gimp2_2
# workaround libgimp not bumping its major on API/ABI changes:
Requires:	%{libname} = %epoch:%{version}
Requires:	gutenprint-gimp2
Requires(post):  desktop-file-utils
Requires(postun):  desktop-file-utils
Conflicts:	perl-Gimp < 2.2

%description
The GIMP is an image manipulation program suitable for photo retouching,
image composition and image authoring.  Many people find it extremely useful
in creating logos and other graphics for web pages.  The GIMP has many of the
tools and filters you would expect to find in similar commercial offerings,
and some interesting extras as well.

The GIMP provides a large image manipulation toolbox, including channel
operations and layers, effects, sub-pixel imaging and anti-aliasing,
and conversions, all with multi-level undo.

This version of The GIMP includes a scripting facility, but many of the
included scripts rely on fonts that we cannot distribute.  The GIMP ftp
site has a package of fonts that you can install by yourself, which
includes all the fonts needed to run the included scripts.  Some of the
fonts have unusual licensing requirements; all the licenses are documented
in the package.  Get them in ftp://ftp.gimp.org/pub/gimp/fonts/ if you are so
inclined.  Alternatively, choose fonts which exist on your system before
running the scripts.

Build Options:
--without python        Disable pygimp (default enabled)
--with    mmx           Enable MMX code support (default disabled)
--with    sse           Enable SSE code support (default disabled)
--with    lzw           Enable LZW compression in GIF (default disabled)

%package -n %{devlibname}-devel
Summary:	GIMP plugin and extension development kit
Group:		Development/GNOME and GTK+
Requires:	libgtk+2.0-devel >= %{req_gtk_version}
Epoch:		1
License:	LGPL
Requires:	%{libname} = %epoch:%{version}
Provides:	gimp-devel = %{version}-%{release}
Provides:	gimp2-devel = %{version}-%{release}
Provides:	libgimp-devel = %{version}-%{release}

%description -n %{devlibname}-devel
Static libraries and header files for writing GIMP plugins and extensions.

%package -n %libname
Summary:	GIMP libraries
Group:		System/Libraries
Epoch:		1
License:	LGPL
Provides:	libgimp%{api_version} = %{version}-%{release}
# (Abel) temporarily for ease of update, should be removed after Mandrake 9.2
Obsoletes:	libgimp12 libgimp17

%description -n %libname
This is the library that provides core GIMP functionality.
It enable other programs to use GIMP's features but is mainly intended
to be used by the GIMP and its "external" plugins.

%package python
Summary:	GIMP python extension
Group:		Graphics
Epoch:		1
Requires:	pygtk2.0
Obsoletes: gimp1_3-python, gimp2_0-python, gimp2_2-python

%description python
This package contains the python modules for GIMP, which act as a
wrapper to libgimp allowing the writing of plug-ins for Gimp.
This is similar to script-fu, except that you can use the full set
of Python extension modules from the plug-in, and you write plug-in
in python instead of in scheme.

%prep
%setup -q -n gimp-%version
#%patch4 -p1 -b .www
#%patch6 -p1 -b .fixname
#%patch7 -p0 -b .mandriva_bug_23486

# needed by patch0
aclocal-1.9 -I m4macros
automake-1.9 

%build
# (Abel) is that -ffast-math fails on other platforms?
%ifarch %ix86 ppc
export CFLAGS="$RPM_OPT_FLAGS -ffast-math"
%endif

%configure2_5x \
	--enable-mp=yes		\
	--enable-gtk-doc=yes	\
	--without-print		\
	--disable-print		\
%if %enable_python
	--enable-python=yes	\
%else
	--enable-python=no	\
%endif
%if %enable_mmx
	--enable-mmx=yes	\
%else
	--enable-mmx=no		\
%endif
%if %enable_sse
	--enable-sse=yes	\
%else
	--enable-sse=no		\
%endif
%if %enable_lzw
	--with-gif-compression=lzw	\
%else
	--with-gif-compression=rle	\
%endif

#gw parallel build is broken
make

%install
rm -fr $RPM_BUILD_ROOT

%makeinstall_std

#clean unpackaged files
rm -f $RPM_BUILD_ROOT%{_libdir}/gimp/%{api_version}/*/*.a
find %buildroot -name \*la|xargs chmod 644

# workaround broken help system                                                                               
HELP_DIR=$RPM_BUILD_ROOT%_datadir/gimp/%api_version/help/C
[[ -d $HELP_DIR ]] || mkdir -p $HELP_DIR
HELP_IDX=$HELP_DIR/introduction.html
echo -e '<HTML><HEAD><TITLE>GIMP Base Library</HEAD>\n<BODY><UL>' > $HELP_IDX

/bin/ls $RPM_BUILD_ROOT%_datadir/gtk-doc/html/*/index.html | sed -e "s@$RPM_BUILD_ROOT@@g" >> $HELP_IDX
perl -pi -e 's!(.*/html/)([^/]*)(/index.html)!<LI><A HREF="\1\2\3">\2</A>!g' $HELP_IDX

echo '</UL></BODY></HTML>' >> $HELP_IDX

%find_lang gimp20 --all-name

%if %enable_python
chmod 755 %buildroot%_libdir/gimp/%{api_version}/plug-ins/*.py
%endif

# Eskild Hustvedt: Add the symlinks to non-versioned executeables
#ln -s %_bindir/gimp-%abi_version $RPM_BUILD_ROOT%_bindir/gimp
#ln -s %_bindir/gimp-console-%abi_version $RPM_BUILD_ROOT%_bindir/gimp-console
#ln -s %_bindir/gimp-remote-%abi_version $RPM_BUILD_ROOT%_bindir/gimp-remote
# Eskild Hustvedt: Add the symlinks to non-versioned manpages
#ln -s %_mandir/man1/gimp-%abi_version $RPM_BUILD_ROOT%_mandir/man1/gimp
#ln -s %_mandir/man1/gimp-%abi_version $RPM_BUILD_ROOT%_mandir/man1/gimp-console
#ln -s %_mandir/man1/gimp-remote-%abi_version $RPM_BUILD_ROOT%_mandir/man1/gimp-remote
#ln -s %_mandir/man1/gimptool-%abi_version $RPM_BUILD_ROOT%_mandir/man1/gimptool
#ln -s %_mandir/man5/gimprc-%abi_version $RPM_BUILD_ROOT%_mandir/man5/gimprc

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_desktop_database
%update_icon_cache hicolor
%update_menus

%postun
%clean_desktop_database
%clean_icon_cache hicolor
%clean_menus

%post -n %libname -p /sbin/ldconfig
%postun -n %libname -p /sbin/ldconfig

%files -f gimp20.lang
%defattr(-,root,root,0755)
%doc %{_datadir}/gtk-doc/html/*
%{_bindir}/*
#%{_datadir}/applications/*
#%{_datadir}/application-registry/*
%{_datadir}/gimp
#%{_datadir}/mime-info/*
%dir %{_libdir}/gimp/%{api_version}
%dir %{_libdir}/gimp/%{api_version}/environ
#%{_libdir}/gimp/%{api_version}/interpreters
%{_libdir}/gimp/%{api_version}/environ/default.env
%{_libdir}/gimp/%{api_version}/modules
%{_libdir}/gimp/%{api_version}/plug-ins
%exclude %{_libdir}/gimp/%{api_version}/plug-ins/*.py
%{_mandir}/man1/gimp*
%{_mandir}/man5/gimprc*
#%_datadir/icons/hicolor/*/apps/gimp.png
#%_datadir/icons/hicolor/scalable/apps/gimp.svg
%config(noreplace) %{_sysconfdir}/gimp

%doc AUTHORS COPYING HACKING INSTALL NEWS
%doc README README.i18n  docs/Wilber*

%files -n %{devlibname}-devel
%defattr(-,root,root,0755)
%doc ChangeLog
%{_bindir}/gimptool-*
%{_datadir}/aclocal/*.m4
%{_includedir}/*
%{_libdir}/lib*.la
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_mandir}/man1/gimptool-*

%files -n %libname
%defattr(-,root,root,755)
%doc COPYING
# explicitly list all libs to avoid old libtool issue
#%{_libdir}/libgimpconfig-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimp-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpthumb-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpbase-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpcolor-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpmath-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpmodule-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpui-%{api_version}.so.%{lib_major}*
%{_libdir}/libgimpwidgets-%{api_version}.so.%{lib_major}*

%if %enable_python
%files python
%defattr(-,root,root,755)
%doc COPYING
%{_libdir}/gimp/%{api_version}/environ/pygimp.env
%{_libdir}/gimp/%{api_version}/python
%{_libdir}/gimp/%{api_version}/plug-ins/*.py
%endif


